import { Client, WebSocketResp } from './client';
export interface WebSocketClientStatus {
    created: boolean;
    connected: boolean;
    login: boolean;
}
export declare type ListenerCallback = (data: WebSocketResp) => void;
export declare class WebSocketClient {
    client: Client;
    interval: number;
    wsUrl: string;
    token: string;
    sid: string;
    chatToken: object;
    status: WebSocketClientStatus;
    constructor(wsUrl: string, token: string, sid: string, chatToken: object);
    init(): Promise<{}>;
    getStatus(): WebSocketClientStatus;
    create(): Promise<{}>;
    on(url: string, callback: (data: WebSocketResp) => void): void;
    off(url: string): void;
    request(url: string, data: object): Promise<WebSocketResp>;
    connect(): Promise<WebSocketResp>;
    ping(): Promise<WebSocketResp>;
    authentication(): Promise<WebSocketResp>;
    onMessage(callback: ListenerCallback): void;
    sendMessage(data: object): Promise<WebSocketResp>;
    markServiced(data: object): Promise<WebSocketResp>;
    getHistoryMessage(data: object): Promise<WebSocketResp>;
}
