import { ReadyStateCallback } from './types/callback';
export interface WebSocketResp {
    value: object | string;
}
declare class Client {
    private _maxPayload;
    private _enableLogger;
    private listeners;
    private requestHeader;
    private responseHeader;
    private url;
    private reconnectTimes;
    private reconnectLock;
    private socket;
    private readyStateCallback;
    constructor(url: string, readyStateCallback: ReadyStateCallback);
    maxPayload: number;
    enableLogger: boolean;
    ping(param: object): Promise<WebSocketResp>;
    request(operator: string, param: object): Promise<WebSocketResp>;
    addMessageListener(operator: string, listener: (data: WebSocketResp) => void): void;
    removeMessageListener(operator: string): void;
    readonly readyState: number;
    setRequestProperty(key: string, value: string): void;
    getRequestProperty(key: string): string;
    setResponseProperty(key: string, value: string): void;
    getResponseProperty(key: string): string;
    private connect;
    reconnect(): void;
    private send;
    asyncSend(operator: string, param: object): Promise<WebSocketResp>;
}
declare function getClient(url: string, callback: ReadyStateCallback): Client;
export { Client, getClient };
